﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Breakout
{
	public enum BallState
	{
		Normal,
		BreakThrough
	}

	public enum Direction
	{
		topleft,
		topright,
		bottomright,
		bottomleft
	}

	class Ball : IGraphicElement
	{
		private int _speed;
		private int _xPos;
		private int _yPos;
		private int _deltaX;
		private int _deltaY;
		private BallState _state;
		private Direction _dir;

		public int Speed
		{
			get { return _speed; }
			set { _speed = value; }
		}

		public Direction BallDirection
		{
			get { return _dir; }
			set { _dir = value; }
		}

		public int XPos
		{
			get { return _xPos; }
			//set { _xPos = value; }
		}

		public int YPos
		{
			get { return _yPos; }
			//set { _yPos = value; }
		}

		public int DeltaX
		{
			get { return _deltaX; }
			set { _deltaX = value; }
		}

		public int DeltaY
		{
			get { return _deltaY; }
			set { _deltaY = value; }
		}

		public BallState State
		{
			get { return _state; }
			set { _state = value; }
		}

		public Ball()
		{
			_deltaX = 1;
			_deltaY = 1;
			_xPos = 36;
			_yPos = 20;
			_speed = 1;
		}

		public void SetPosition(int x, int y)
		{
			ClearOld();
			_yPos = y;
			_xPos = x;
			Draw();
		}

		public void Draw()
		{
			Console.CursorTop = _yPos;
			Console.CursorLeft = _xPos;
			Console.ForegroundColor = ConsoleColor.Yellow;
			Console.Write("*");
		}

		public void ClearOld()
		{
			Console.CursorTop = _yPos;
			Console.CursorLeft = _xPos;
			Console.ForegroundColor = ConsoleColor.Black;
			Console.Write(" ");
		}
	}
}
