﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Timers;

namespace Breakout
{
	class GameEngine
	{
		private ConsoleKeyInfo _cki;

		private bool _runGame;
		private Panel _thePanel;
		private Ball _theBall;
		private PlayGround _thePlayGround;
		private PhysicsEngine _physEng;

		private Timer _gamingTimer;

		public GameEngine()
		{
			this._runGame = true;

			_thePanel = new Panel(6);
			_thePanel.XPos = (40 - (_thePanel.Width / 2));

			_gamingTimer = new Timer();
			_gamingTimer.Interval = 50;

			_theBall = new Ball();

			_physEng = new PhysicsEngine();
		}

		public void Run()
		{
			Console.CursorVisible = false;

			_gamingTimer.Elapsed += new ElapsedEventHandler(_gamingTimer_Elapsed);

			_gamingTimer.Enabled = true;

			while(_runGame)
			{
					_cki = Console.ReadKey();

					switch (_cki.Key)
					{
						case ConsoleKey.LeftArrow:
							HandleLeft();
							break;

						case ConsoleKey.RightArrow:
							HandleRight();
							break;

						case ConsoleKey.SpaceBar:
							HandleSpace();
							break;

						case ConsoleKey.Escape:
							HandleEscape();
							break;
					}
				
			}
		}
		void _gamingTimer_Elapsed(object sender, ElapsedEventArgs e)
		{
			try
			{		
				_physEng.RunBall(this._theBall, this._thePanel);
			}
			catch (Exception ex)
			{
				_gamingTimer.Enabled = false;
				Console.Clear();

				Console.ForegroundColor = ConsoleColor.Red;
				Console.CursorLeft = 35;
				Console.CursorTop = 12;
				Console.Beep(3000, 5000);
				Console.Write("GAME OVER");
			}
		}

		private void HandleEscape()
		{
			_runGame = false;			
		}

		private void HandleLeft()
		{
			_thePanel.XPos -= 1;
		}

		private void HandleRight()
		{
			_thePanel.XPos += 1;
		}

		private void HandleSpace()
		{

		}
	}
}
