﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Breakout
{
	public enum PanelStyle
	{
		Standard,
		Turbo,
		Glue
	}

	class Panel : IGraphicElement
	{
		private int _width;
		private PanelStyle _style;
		private int _xPos;

		public int Width
		{
			get { return _width; }
			set { _width = value; }
		}

		public PanelStyle Style
		{
			get { return _style; }
			set { _style = value; }
		}

		public int XPos
		{
			get {return _xPos; }
			set 
			{
				if ((value >= 0) && (value + _width <= 79))
				{
					ClearOld();
					_xPos = value;

					Draw();
				}
			}
		}

		public Panel(int width)
		{
			_width = width;
			_xPos = -1;
		}

		public void Draw()
		{
			Console.CursorTop = 24;
			Console.CursorLeft = (_xPos );
			Console.BackgroundColor = ConsoleColor.Black;

			switch (_style)
			{
				case PanelStyle.Standard:
					HandleStandard();
					break;
			}
		}

		public void ClearOld()
		{
			if (_xPos >= 0)
			{
				Console.CursorLeft = _xPos;
				Console.BackgroundColor = ConsoleColor.Black;
				Console.Write(string.Empty.PadLeft(_width, ' '));
			}
		}

		private void HandleStandard()
		{
			Console.ForegroundColor = ConsoleColor.Gray;
			Console.Write(string.Empty.PadLeft(_width, '='));
		}
	}
}
