﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace ConsoleApplication1
{

	class Ball
	{
		public int x = 40;
		public int y = 24;
		public int dx = -1;
		public int dy = -1;
	}

	class Program
	{

		static char[,] spielfeld;
		static char[,] screenbuffer;
		static ConsoleColor[,] forecolor;
		static ConsoleColor[,] backcolor;

		static int pause = 10;

		static int leben = 5;
		static int punkte = 0;
		static int padx = 36;
		static int padBreite = 8;

		static List<Ball> baelle = new List<Ball>();

		static void Main(string[] args)
		{
			screenbuffer = new char[80, 25];
			forecolor = new ConsoleColor[80, 25];
			backcolor = new ConsoleColor[80, 25];

			Init();

			ConsoleKeyInfo consolekey = new ConsoleKeyInfo();

			ZeichneSpielfeld();

			do
			{

				if (leben < 0)
				{
					Init();
					baelle[0].x = 40;
					baelle[0].y = 24;
					baelle[0].dx = 1;
					baelle[0].dy = -1;
					leben = 5;
					punkte = 0;
				}

				try
				{

					int cntr = 0;

					do
					{
						cntr++;
						
						if (cntr > pause)
						{
							
							BewegeBälle();
							ZeichnePanel();
							ZeichneBuffer();
							cntr = 0;

							ConsoleSetCursorPosition(0, 0);

							Console.BackgroundColor = ConsoleColor.Black;
							Console.ForegroundColor = ConsoleColor.DarkMagenta;

							string ausgabe = "Leben: " + leben + " Punkte: " + punkte;

							foreach (char chr in ausgabe) ConsoleWrite(chr);
						}

						if (Console.KeyAvailable)
						{
							consolekey = Console.ReadKey(true);

							switch (consolekey.Key)
							{
								case ConsoleKey.LeftArrow:
									if (padx > 0) padx--;
									break;
								case ConsoleKey.RightArrow:
									if (padx < (79 - padBreite)) padx++;
									break;
							}
						}



					} while (consolekey.Key != ConsoleKey.Escape);
				}
				catch (SpielerTotException ex)
				{
					leben--;
					for (int f = 2000; f > 1000; f-= 50)
						Console.Beep(f, 1);
				}

			} while (consolekey.Key != ConsoleKey.Escape);

		}

		static void ZeichneSpielfeld()
		{
			Console.BackgroundColor = ConsoleColor.Black;
			Console.ForegroundColor = ConsoleColor.Black;

			for (int y = 0; y < 24; y++)
				for (int x = 0; x < 80; x++)
				{
					ConsoleSetCursorPosition(x, y);

					switch (spielfeld[x, y])
					{
						case '.':
							Console.ForegroundColor = ConsoleColor.Black;
							break;
						case 'x':
							Console.ForegroundColor = ConsoleColor.Blue;
							break;
						case 's':
							Console.ForegroundColor = ConsoleColor.Green;
							break;
						case 'l':
							Console.ForegroundColor = ConsoleColor.Red;
							break;
						case 'm':
							Console.ForegroundColor = ConsoleColor.White;
							break;
						case 'g':
							Console.ForegroundColor = ConsoleColor.Cyan;
							break;
						case 'k':
							Console.ForegroundColor = ConsoleColor.Yellow;
							break;
					}

					ConsoleWrite(spielfeld[x, y]);
				}
		}

		static void ZeichnePanel()
		{
			Console.ForegroundColor = ConsoleColor.Black;
			Console.BackgroundColor = ConsoleColor.Black;
			
			for (int x = 0; x < 79; x++)
			{
				ConsoleSetCursorPosition(x, 24);
				ConsoleWrite(" ");
			}

			ConsoleSetCursorPosition(padx, 24);
			Console.BackgroundColor = ConsoleColor.Gray;

			for (int i = 0; i < padBreite; i++) ConsoleWrite(" "); 
		}

		static void ZeichneBuffer()
		{
			for (int y = 0; y < 25; y++)
				for (int x = 0; x < 80; x++)
				{
					if ((y == 24) && (x == 79)) break;
					Console.SetCursorPosition(x, y);
					Console.ForegroundColor = forecolor[x, y];
					Console.BackgroundColor = backcolor[x, y];
					Console.Write(screenbuffer[x, y]);
				}
		}

		static void BewegeBälle()
		{
			foreach (Ball b in baelle)
			{
				ConsoleSetCursorPosition(b.x, b.y);
				Console.BackgroundColor = ConsoleColor.Black;
				Console.ForegroundColor = ConsoleColor.White;
				ConsoleWrite(" ");


				b.x += b.dx;
				b.y += b.dy;

				if (b.y < 0) { b.y = 0; b.dy = 1; }
				if (b.x < 0) { b.x = 0; b.dx = 1; }
				if (b.y == 25) { b.y = 24; b.dy = -1; throw new SpielerTotException("Game Over!"); }
				if (b.x == 80) { b.x = 79; b.dx = -1; }

				if ((b.y == 24) && (b.x >= padx) && (b.x < (padx + padBreite)))
				{
					b.dy = -1;
				}

				if (spielfeld[b.x, b.y] != '.')
				{

					Console.Beep();
					/*
			 * x normal
			 * s schneller
			 * l langsamer
			 * m mehr Bälle
			 * g größer
			 * k kleiner
			 */
					punkte++;
					switch (spielfeld[b.x, b.y])
					{
						case 's':
							if (pause > 0) pause--;
							break;
						case 'l':
							pause++;
							break;
						case 'g':
							if (padBreite < 20) padBreite++;
							break;
						case 'k':
							if (padBreite > 4) padBreite--;
							break;

					}

					spielfeld[b.x, b.y] = '.';
					b.x -= b.dx;
					b.y -= b.dy;
					b.dx *= -1;
					b.dy *= -1;

					ZeichneSpielfeld();
				}


				if (b.y < 0) { b.y = 0; b.dy = 1; }
				if (b.x < 0) { b.x = 0; b.dx = 1; }
				if (b.y == 25) { b.y = 24; b.dy = -1; throw new SpielerTotException("Game Over!"); }
				if (b.x == 80) { b.x = 79; b.dx = -1; }


				ConsoleSetCursorPosition(b.x, b.y);
				Console.BackgroundColor = ConsoleColor.Black;
				Console.ForegroundColor = ConsoleColor.White;
				ConsoleWrite("*");
			}
		}

		static void Init()
		{
			spielfeld = new char[80, 25];

			for (int y = 0; y < 25; y++)
				for (int x = 0; x < 80; x++)
				{
					spielfeld[x, y] = ' ';
					backcolor[x, y] = ConsoleColor.Black;
					forecolor[x, y] = ConsoleColor.Black;
				}


			StreamReader sr = File.OpenText(@"c:\level.txt");


			for (int y = 0; y < 25; y++)
				for (int x = 0; x < 80; x++)
				{
					int c;
					do
					{
						c = sr.Read();
					} while ((c == 13) || (c == 10));


					spielfeld[x, y] = (char)c;
				}


			/*
			 * x normal
			 * s schneller
			 * l langsamer
			 * m mehr Bälle
			 * g größer
			 * k kleiner
			 */

			baelle.Add(new Ball());

		}

		static int cx = 0;
		static int cy = 0;

		static void ConsoleWrite(object o)
		{
			char c = (char)o.ToString()[0];
			screenbuffer[cx, cy] = c;
			forecolor[cx, cy] = Console.ForegroundColor;
			backcolor[cx, cy] = Console.BackgroundColor;
			cx++;
		}

		static void ConsoleSetCursorPosition(int x, int y)
		{
			cx = x; cy = y;
		}
	}
}
